<template>
  <rui-form :errors="errors"
            model="layer"
            :loading="loading"
            :submit-button-title="harvest?.id ? $t('generic.edit') : $t('generic.save')"
            @cancel="handleCancel"
            @submit.prevent="save">
    <rui-field input-id="quantity" :label="$t('activerecord.attributes.harvest.quantity')">
      <input id="quantity"
             v-model="inputs.quantity"
             type="number"
             min="0"
             step="0.01"
             required>
    </rui-field>

    <rui-field input-id="unit" :label="$t('activerecord.attributes.harvest.unit')">
      <select id="unit" v-model="inputs.unit" required>
        <option v-for="unit in units" :key="unit" :value="unit">{{ $t(`js.unit.${unit}`) }}</option>
      </select>
    </rui-field>

    <rui-date-time-picker v-model="inputs.harvestedAt" input-name="harvested_at" :time="false" :label="$t('activerecord.attributes.harvest.harvested_at')" />
  </rui-form>
</template>

<script>
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'
import RuiDateTimePicker from '@experiments-labs/rise_ui/src/components/Inputs/DateTimePicker/DateTimePicker.vue'

import Toaster from '@/vue/tools/Toaster'
import { converters, Units } from '@/helpers/Units'
import Harvest from '../../../../classes/models/Harvest'
import Element from '../../../../classes/models/Element'

export default {
  name: 'GpaHarvestForm',
  emits: [
    'cancel',
    'done',
  ],
  components: { RuiDateTimePicker, RuiField, RuiForm },
  props: {
    /** Element, in the case of a creation */
    element: { required: false, type: Element, default: null },
    /** Harvest, in the case of an edition */
    harvest: { required: false, type: Harvest, default: null },
  },
  data () {
    return {
      inputs: { ...this.fillInputs() },
      errors: null,
      loading: false,
      units: Units,
    }
  },
  methods: {
    fillInputs () {
      return {
        quantity: this.harvest?.quantity,
        unit: this.harvest?.unit,
        harvestedAt: this.harvest?.harvestedAt || new Date(),
      }
    },
    handleCancel () {
      this.inputs = this.fillInputs()
      this.$emit('cancel')
    },
    save () {
      const payload = {
        id: this.harvest?.id,
        quantity: converters[this.inputs.unit].convert(this.inputs.quantity),
        unit: converters[this.inputs.unit].unit,
        element_id: this.harvest?.elementId || this.element?.id,
        harvested_at: this.inputs.harvestedAt,
      }
      if (!payload.id) { delete payload.id }

      this.loading = true
      this.errors = null
      this.$store.dispatch('saveHarvest', payload)
        .then((harvest) => {
          Toaster.success(this.$t('js.generic.successfully_saved'))
          this.$emit('done', harvest)
        })
        .catch((errors) => {
          Toaster.error(this.$t('js.generic.failed_to_save'))
          this.errors = errors
        })
        .then(() => { this.loading = false })
    },
  },
  watch: {
    harvest () {
      this.inputs = { ...this.fillInputs() }
    },
  },
}
</script>
